#ifndef _UART_H
#define _UART_H

// Baudrates
//   Value for UBRR register:
//     UBRR = F_CPU / (16 * baudrate) - 1
//   With rounding:
//     UBRR = round(F_CPU / (16 * baudrate) - 1)
//          = round(F_CPU / (16 * baudrate)) - 1
//          = floor(F_CPU / (16 * baudrate) + 0.5) - 1
//          = floor((F_CPU + 8 * baudrate) / (16 * baudrate)) - 1
typedef enum {
	BAUD_9600   = ((F_CPU + 8 *   9600UL) / (16 *   9600UL)) - 1,
	BAUD_19200  = ((F_CPU + 8 *  19200UL) / (16 *  19200UL)) - 1,
	BAUD_38400  = ((F_CPU + 8 *  38400UL) / (16 *  38400UL)) - 1,
	BAUD_57600  = ((F_CPU + 8 *  57600UL) / (16 *  57600UL)) - 1,
	BAUD_115200 = ((F_CPU + 8 * 115200UL) / (16 * 115200UL)) - 1,
	BAUD_230400 = ((F_CPU + 8 * 230400UL) / (16 * 230400UL)) - 1,
	BAUD_460800 = ((F_CPU + 8 * 460800UL) / (16 * 460800UL)) - 1,
	BAUD_921600 = ((F_CPU + 8 * 921600UL) / (16 * 921600UL)) - 1,
} baud_T;

void uart_init(baud_T ubrr);
void uart_disable(void);
uint8_t uart_data_available(void);
uint8_t uart_getc(void);
void uart_putc(uint8_t data);

#endif
